#!/usr/bin/perl

require "config.pl";

if ($ENV{'REQUEST_METHOD'} eq "GET") {
 $buffer = $ENV{'QUERY_STRING'};
} 
elsif ($ENV{'REQUEST_METHOD'} eq "POST") {
 read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
}
@pairs = split(/&/, $buffer);
foreach $pair (@pairs) {
 ($name, $value) = split(/=/, $pair);
 $value =~ tr/+/ /;
 $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
 $value =~ s/<([^>]|\n)*>//g;
 $value =~ s/<!--(.|\n)*-->//g;
 #    :
 $value =~ s/^\s+//;
 $value =~ s/\s+$//;
 $FORM{$name} = $value;
}

print "Content-type: text/html\n\n";
$action = $FORM{'action'};
if ($action eq 'formula') { 
 &html_start2;
 &formula; 
 &html_end2;
}
else {
 &html_start;
 if ($action eq 'search') { &search; }
 else { &mainform; }
 &html_end;
}
exit;

sub mainform {
 ($cod, $authors, $number, $name, $owner, $mki, $priority, $publication, $keywords, $annotation, $goal, $formula, $mode, $file)=@_;

 if ($file ne "") { unlink ("$basedir/$file"); }

 print <<"[END]";
<SCRIPT language="JavaScript">
<!--
function help1 () {
 Win=window.open("help.html","pollwindow", 
  "toolbar=no,scrollbars=yes,directories=no,status=no,menubar=no,resizable=no,width=600,height=400");
}

function clear1 () {
 document.f1.number.value="";
 document.f1.authors.value="";
 document.f1.name.value="";
 document.f1.owner.value="";
 document.f1.mki.value="";
 document.f1.priority.value="";
 document.f1.publication.value="";
 document.f1.keywords.value="";
 document.f1.annotation.value="";
 document.f1.goal.value="";
 document.f1.formula.value="";
}
-->
</SCRIPT>
[END]

 print"<form action=index.pl name=f1 method=post><table width=$mainwidth border=0><input type=hidden name=action value=search><center><b>  :</b></center>\n";

 print"<tr><td align=right><b> </b></td><td><input type=text class=button name=number value=\"$number\" size=50></td></tr>\n";
 print"<tr><td align=right><b></b></td><td><input type=text class=button name=authors value=\"$authors\" size=50></td></tr>\n";
 print"<tr><td align=right><b></b></td><td><input type=text class=button name=name value=\"$name\" size=50></td></tr>\n";
 print"<tr><td align=right><b></b></td><td><input type=text class=button name=owner value=\"$owner\" size=50></td></tr>\n";
 print"<tr><td align=right><b></b></td><td><input type=text class=button name=mki value=\"$mki\" size=50></td></tr>\n";
 print"<tr><td align=right><b></b></td><td><input type=text class=button name=priority value=\"$priority\" size=50></td></tr>\n";
 print"<tr><td align=right><b></b></td><td><input type=text class=button name=publication value=\"$publication\" size=50></td></tr>\n";

 print"<tr><td align=right><b> </b></td><td><input type=text class=button name=keywords value=\"$keywords\" size=50></td></tr>\n";
 print"<tr><td align=right><b></b></td><td><input type=text class=button name=annotation value=\"$annotation\" size=50></td></tr>\n";
 print"<tr><td align=right><b> </b></td><td><input type=text class=button name=goal value=\"$goal\" size=50></td></tr>\n";
 print"<tr><td align=right><b> </b></td><td><input type=text class=button name=formula value=\"$formula\" size=50></td></tr>\n";

 print"<tr><td colspan=2 align=center><input type=submit class=button name=ok value=\"\">\n";
 print"<input type=button class=button name=cancel value=\"\" onClick=\"clear1()\">\n";
 print"<input type=button class=button name=help value=\"\" onClick=\"help1()\">\n";
 print"</td></tr><tr><td colspan=2><input type=radio ";
 if ($mode eq 'yes') { print "checked "; }
 print "name=mode value=yes>    <br>";
 print"<input type=radio ";
 if ($mode ne 'yes') { print "checked "; }
 print "name=mode value=no>      <br>";
 print"</td></tr></table></form>";
}

sub table1 {
 my ($cod0, $authors0, $number0, $name0, $owner0, $mki0, $priority0, $publication0, $keywords0, $annotation0, $goal0, $formula0, $mod) = @_;
     print "<table width=$mainwidth border=0>\n";
     print "<tr><td> :</td><td>$number0</td></tr>\n";
     print "<tr><td>:</td><td>$authors0</td></tr>\n";
     print "<tr><td>:</td><td>$name0</td></tr>\n";
     print "<tr><td>:</td><td>$owner0</td></tr>\n";
     print "<tr><td>:</td><td>$mki0</td></tr>\n";
     print "<tr><td>:</td><td>$priority0</td></tr>\n";
     print "<tr><td>:</td><td>$publication0</td></tr>\n";
     print "<tr><td> :</td><td>$keywords0</td></tr>\n";
     print "<tr><td>:</td><td>$annotation0</td></tr>\n";
     print "<tr><td> :</td><td>$goal0";
     if ($mod==0) { 
      print "(<a href=\"$cginame?action=formula&cod=$cod0\" target=_blank></a>)";
     }
     print "</td></tr>\n";
     if ($mod==1) {
      print "<tr><td> :</td><td>$formula0</td></tr>";
     }
     print "</td></tr></table><center><hr width=$mainwidth size=2 noshade color=#8ed8f8></center>\n";
}

sub search {
 $start=$FORM{'start'};
 $mode=$FORM{'mode'};

 if ($start eq "") { 
  $start=1; 
  $cod=$FORM{'cod'}; 
  $authors=$FORM{'authors'};
  $number=$FORM{'number'};
  $name=$FORM{'name'};
  $owner=$FORM{'owner'};
  $mki=$FORM{'mki'};
  $priority=$FORM{'priority'};
  $publication=$FORM{'publication'};
  $keywords=$FORM{'keywords'};
  $annotation=$FORM{'annotation'};
  $goal=$FORM{'goal'};
  $formula=$FORM{'formula'};
 }
 else {
  $file=$FORM{'file'}; 
  if ($file ne "") {
   open (FILE1, "$basedir/$file");
   $saved=<FILE1>;
   close(FILE1);
   ($cod, $authors, $number, $name, $owner, $mki, $priority, $publication, $keywords, $annotation, $goal, $formula) = split(/\t/, $saved);
   unlink ("$basedir/$file");    
  }
 }

 &mainform ( $cod, $authors, $number, $name, $owner, $mki, $priority, $publication, $keywords, $annotation, $goal, $formula, $mode, $file );

 $lcod=&lcr($cod);
 $lauthors=&lcr($authors);
 $lnumber=&lcr($number);
 $lname=&lcr($name);
 $lowner=&lcr($owner);
 $lmki=&lcr($mki);
 $lpriority=&lcr($priority);
 $lpublication=&lcr($publication);
 $lkeywords=&lcr($keywords);
 $lannotation=&lcr($annotation);
 $lgoal=&lcr($goal);
 $lformula=&lcr($formula);

 open(DATA, "$basename");
 @data = <DATA>;
 close(DATA);
 if (@data) {
  $lines=0;
  $fields=0;
  if ($lauthors ne "") { $fields++; }
  if ($lnumber ne "") { $fields++; }
  if ($lname ne "") { $fields++; }
  if ($lowner ne "") { $fields++; }
  if ($lmki ne "") { $fields++; }
  if ($lpriority ne "") { $fields++; }
  if ($lpublication ne "") { $fields++; }
  if ($lkeywords ne "") { $fields++; }
  if ($lannotation ne "") { $fields++; }
  if ($lgoal ne "") { $fields++; }
  if ($lformula ne "") { $fields++; }

  foreach $line(@data) {
   chomp($line);
   $found=0;
   ($cod0, $authors0, $number0, $name0, $owner0, $mki0, $priority0, $publication0, $keywords0, $annotation0, $goal0, $formula0) = split(/\t/, $line);
   $lcod0=&lcr($cod0);
   $lauthors0=&lcr($authors0);
   $lnumber0=&lcr($number0);
   $lname0=&lcr($name0);
   $lowner0=&lcr($owner0);
   $lmki0=&lcr($mki0);
   $lpriority0=&lcr($priority0);
   $lpublication0=&lcr($publication0);
   $lkeywords0=&lcr($keywords0);
   $lannotation0=&lcr($annotation0);
   $lgoal0=&lcr($goal0);
   $lformula0=&lcr($formula0);

   if ($lauthors ne "") {
    if (index2 ($lauthors,$lauthors0)>-1) { $found++; }
   }
   if ($lnumber ne "") {
    if (index2 ($lnumber,$lnumber0)>-1) { $found++; }
   }
   if ($lname ne "") {
    if (index2 ($lname,$lname0)>-1) { $found++; }
   }
   if ($lowner ne "") {
    if (index2 ($lowner,$lowner0)>-1) { $found++; }
   }
   if ($lmki ne "") {
    if (index2 ($lmki,$lmki0)>-1) { $found++; }
   }
   if ($lpriority ne "") {
    if (index2 ($lpriority,$lpriority0)>-1) { $found++; }
   }
   if ($publication ne "") {
    if (index2 ($lpublication,$lpublication0)>-1) { $found++; }
   }
   if ($lkeywords ne "") {
    if (index2 ($lkeywords,$lkeywords0)>-1) { $found++; }
   }
   if ($lannotation ne "") {
    if (index2 ($lannotation,$lannotation0)>-1) { $found++; }
   }
   if ($lgoal ne "") {
    if (index2 ($lgoal,$lgoal0)>-1) { $found++; }
   }
   if ($lformula ne "") {
    if (index2 ($lformula,$lformula0)>-1) { $found++; }
   }

   if  ( (($mode eq "no") and ($found>0)) or 
         (($mode eq "yes") and ($found == $fields)) ) {
    if ($lines == 0) {
     print "<p><center><b> </b></center></p>\n";
     print "<center><hr width=$mainwidth size=2 noshade color=#8ed8f8></center>\n";
    }
    $lines++;
    if (($lines >= $start) && ($lines<$start+$out)) {
     &table1 ($cod0, $authors0, $number0, $name0, $owner0, $mki0, $priority0, $publication0, $keywords0, $annotation0, $goal0, $formula0, 0);
    }
   }
  }
  &tab_start;

  $file=&TempName;
  $str="$cod\t$authors\t$number\t$name\t$owner\t$mki\t$priority\t$publication\t$keywords\t$annotation\t$goal\t$formula";
  open (FILE1, ">$basedir/$file");
  flock(FILE1,2);
  print FILE1 "$str";
  flock(FILE1,8);
  close(FILE1);

  for ($i=0; $i<$lines; $i+=$out) {
   $down=$i+1;
   $up=$i+$out;
   if ($up>$lines) { $up=$lines; }
   if ($start != $down) {
    print "[<a href=\"$cginame?action=search&start=$down&file=$file&mode=$mode\">";
    if ($down < $up) { print "$down-$up"; }
    else { print "$down"; }
    print "</a>]";
   }
   else {
    if ($down<$up) { print "[$down-$up]"; }
    else { print "[$down]"; }
   }
  }
  &tab_end;
  $all=$#data+1;
  &tab_start;
  if ($lines>0) { print "<i> : $lines"; }
  else { print ",      "; }
  print "<br>  : $all</i>\n";
  &tab_end;
 } 
 else {
  &tab_start;
  print "<p> '$basename'      !   </p>";
  &tab_end;
 }
}

sub formula {
 $cod=$FORM{'cod'};
 if ($cod ne "") {
  open(DATA, "$basename");
  @data = <DATA>;
  close(DATA);
  foreach $line(@data) {
   chomp($line);
   $found=0;
   ($cod0, $authors0, $number0, $name0, $owner0, $mki0, $priority0, $publication0, $keywords0, $annotation0, $goal0, $formula0) = split(/\t/, $line);
   if ("$cod" eq "$cod0") {
    &table1 ($cod0, $authors0, $number0, $name0, $owner0, $mki0, $priority0, $publication0, $keywords0, $annotation0, $goal0, $formula0, 1);
    return;    
   }
  }
 }
 else {
  &tab_start;
  print "<p>       $cod.     </p>";
  &tab_end;  
 }
}